Ruby master - Feature #4147

Array#sample 000000000
12/10/2010 10:06 PM - oj (Yoji Ojima)

Status: Feedback
Priority: Normal
Assignee:

Target version:

Description

=begin

Array#sample 0000000000000000000000000DO00DO0DDO0DOO0DO0D

00ooooood-pa-0-0+0 1ooo OODOODODDODOODOODOD

omikuji_box = [

{zname => "[[I", :weight => 1000},
{zname => "[I", :weight => 100},
{zname => "0[I", :weight => 10},
{:name =>"[I", :weight => 1}

]
omikuji = omikuji_box.sample {|v| v[:weight] }
puts omikuji[:name]

=end

Related issues:

Related to Ruby master - Feature #4247: New features for Array#sample, Array#...

Assigned

History

#1 - 12/10/2010 10:22 PM - shyouhei (Shyouhei Urabe)
- Status changed from Open to Feedback

=begin

[I[I[I[IIEI[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I
00Rubyd00000000000000000000000000000
000000oooboooooononnoonooncnnnoonnannoonoannaO

=end
#2 - 12/10/2010 10:45 PM - sorah (Sorah Fukumori)

=begin
RubyU000000000000D0O00O00DO0DO00DO0DO0DD00D

class Array

def sample(n=1)

if block_given?
self.size.times.map do |i|
Array.new(yield(selffi]), self[i])
end.flatten.sample(n)

else

n == 1 ? self[rand(self.size)] : Array.new(n){ self[rand(self.size)] }
end

end

end

#-- 000

def a
[1,2,3].sample { |v| v*100 }
end

defb

[1,2,3].sample { |v| v*100 }
end

ary = 100.times.map{a}
bry = 100.times.map{b}
result_a = {}

ary.each do |i|
result_a[i] ||= 0
result_a[i] +=1
end

result_b = {}

bry.each do |i|
result_b[i] ||=0
result_b[i] += 1
end

#all i*10000000 o000000 §i => 0000

p result_a #=> {2=>31, 3=>56, 1=>13}
p result_b #=> {2=>37, 3=>45, 1=>18}

#--sora_h
=end

#3 - 12/10/2010 10:47 PM - sorah (Sorah Fukumori)

=begin
goooooooooo

#-- 000

defa
[1,2,3].sample { |v| v*100 }
end

defb

[1,2,3].sample { |v| v }
end

ary = 100.times.map{a}
bry = 100.times.map{b}

result_a = {}

ary.each do |i|
result_afi] ||=0
result_a[i] += 1
end

result_b = {}

bry.each do |i|
result_b[i] ||= 0
result_b[i] +=1
end

#all i*10000000 o00000D {i => 000Dy

p result_a #=> {3=>56, 1=>13, 2=>31}
p result_b #=> {2=>34, 3=>46, 1=>20}

#-- sora_h
=end

#4 - 12/10/2010 10:58 PM - oj (Yoji Ojima)

=begin
00000000000O0nono0nonnooononng

class Array
alias :org_sample :sample

def sample

if block_given?

prob_map = collect {|v| yield(v) }

rn = rand * prob_map.inject(0) {|r, v| r +=v }
prob_map.each_with_index do |v, i|

m-=v
return self[i]if rn <0
end

else

org_sample

end

end

end

=end

#5 - 12/10/2010 11:00 PM - oj (Yoji Ojima)

=begin
000ooooooooooa

=end
#6 - 12/18/2010 04:20 PM - oj (Yoji Ojima)

=begin
(10000000000000DO0000OD000DaD00DaD00DOD00DOD0DDOD00DOD00DOD00DOD00DOD0EDO

=end

#7 - 12/19/2010 01:37 AM - shyouhei (Shyouhei Urabe)
- Status changed from Feedback to Assigned

- Assignee set to shyouhei (Shyouhei Urabe)

=begin
DDDﬁDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD

000cO0oo0bonnoonoonnonnoonhonnoonoOnhannOODDhO0DO0DD00DO0Da

=end

#8 - 12/19/2010 10:31 AM - hasari (Hiro Asari)

=begin
aooooo

00000000o0o0DonooDonDnono0DonoO
0000000o0booooonoonDo0noO0DO0DO0gemODOODODDOODDD

=end
#9 - 12/19/2010 11:15 AM - oj (Yoji Ojima)

=begin
DDDdDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD
0000000000000000000000n0no0n00naOon0onnan

=end

#10 - 12/19/2010 11:25 AM - mame (Yusuke Endoh)

=begin
aoooo

201000120018[116:20 Yoji Ojima redmine@ruby-lang.org:

000000oDODoonoDODODODODODODO0n0DOD0DonOnaDaDO0D0DODODoDonaDaDODD0DODnaDg

0000000000a00on0AP DODOODODODD
000000 each DOOOODODODOD

00000DoDoDoDoooonoDoDoDoDoDoDaDaDnD

omikuiji_box = %w(00 00 00 0)
omikuji_weight = [1000, 1100, 1110, 1111]

omikuji = omikuji_box.sample(weight: omikuji_weight)
000o0ooooooon

00000000000000000000000000 each OOOOD
0000000ooDoohonoobonooDoDDoD
00000000000000000000000O0a0a000na0g
000000000000000000n0no0no
0000000000O0000000D0000oDononananO
HHHHHDDDDDDDDDDDDDDDDD AP 0000000

Yusuke Endoh mame@tsg.ne.jp

=end

#11 - 12/19/2010 11:44 AM - hasari (Hiro Asari)

=begin
On Dec 18, 2010, at 9:15 PM, Yoji Ojima wrote:

0000oDoDoDooooDoDoDoDODODODODO0nODnODnaDg
00000000000000000000000a0000000000a0a0
0000obononopopooo

0000000000000000000000000000000000000000a0
00000000oDopoonononobononononanonD

1.90Math.gammallMath.lgammal0000000JRuby0000000
(100000000DO000DoonoDooooDoOon

=end
#12 - 12/19/2010 11:48 AM - hasari (Hiro Asari)

=begin
0000000ooDoonoonnonnoonbonnoonoonDa

=end
#13 - 12/19/2010 12:41 PM - oj (Yoji Ojima)
=begin

100000 each OOO0DDDOOOO0

000000oDoDo0oonoDoDoDoDODoDO000nODODODODaDaDaD00DnODODODnaDaD
00000000oDODO00oDODODOD0D Ruby ODODODODODODODODOODOD

=end

#14 - 12/19/2010 01:33 PM - mame (Yusuke Endoh)

=begin
aoooo

2010001200190012:41 Yoji Ojima redmine@ruby-lang.org:

000000 each 0DODODODODOD

000000oDo0oonoDoDODoDoDODODO0DnODODoDonODaDaDO0D0DODODODnaDaD
000000O0O0o0nonoDoDoDo0oD ruby ODODODODODOCDOODODODOD

000000000000000000000000000 Ruby OOOD
0000000000O0o00onoDoDoDoDonoDa0anO
0000o0opoonono

00000000000000000000Asari 0OODODODODO
0000000000O0000000000O
0000000000000000n0000000nononanonn
0000000000O000000000000onononanang
000000ODoDoDoDoooonODODODoDODaD

00000new feature 000000000000000000000matz

00o0oo
0000000000 matz 00O0DOODOOODO
0000000000 matz 0O000000O0DOO
0000000000000000000000 matz DO0D00DODOD
0000oDoDoDoonoDoDoDoDoD

Yusuke Endoh mame@tsg.ne.jp

=end

#15 - 12/19/2010 02:03 PM - mame (Yusuke Endoh)

=begin
20100120190013:33 Yusuke ENDOH mame®@tsg.ne.jp:

HHHHHEewfeanueDDDDDDDDDDDDDDDDDDDDDma&
(0000000000 matz 0000O000DOOCD

0oooo
0000000000Omatz O0ODOODODODODODODD

00000 fruby-dev:42791] 00000000000000000000
00000000000000 matz DOODODOODOODODOCOD
ooy ooo

Yusuke Endoh mame@tsg.ne.jp

=end

#16 - 12/19/2010 02:06 PM - tarui (Masaya Tarui)
=begin

000000000000000000000000000000a00Da0Da0no0DD00Da0DD
00000000ooDo0DbonoohonoobonoonanoD

00000DoDoDoDoDoooononoDng

000samplel0000000000000000000iem000000000000000
0000bopoonoohonoobonoo

loooooooooooooo

[ruby-dev:41918] [Feature #3647] Array#sample(n, replace=false)
aoonoooon

matz[0000000000000000000000000000000000
00000000000000000000000000

#364700000000000000000000s00000000000
1)0000000000000000
2)00000000000000-1000 (-:000000000000D)
3)0000000000000DO0na0noon

000000000000000000DoDna0
0000o0opooonono

00000DoDoDoDoonoDODoDODODoDananD

0000(Masaya TARUI)
No Tool,No Life.

=end

#17 - 12/19/2010 02:33 PM - shyouhei (Shyouhei Urabe)

=begin
(2010/12/19 14:02), Yusuke ENDOH wrote:

00000 [ruby-dev:42791] 00000000000000000000
qﬁﬁ?qﬂﬂ?ﬂﬂﬂﬂﬂﬂrnszDDDDDDDDDDDDDDDD
(Ut
000000000tunk00000DOODOOODOODOODDOODOODD
gooooo

00000000000000000000000000D000000Dan0aO
00000o00oonooDonoono0hono0DoDDoD

=end

#18 - 12/19/2010 02:36 PM - oj (Yoji Ojima)
=begin

#364700000000000000000000300000000000
1)0000000000000000
2)00000000000000-1000 (:000000000000)
3)0000000000O0O0000nODnODaD

4) 000000ODODODO0 o DOOO
00000DoDoDoDoDoooononoDng

=end

#19 - 12/19/2010 03:20 PM - oj (Yoji Ojima)
=begin

0000oDoDoDooooDoDODoDoDODODanooD

R O00000DODODODODODODODODDODOD

http://stat.ethz.ch/R-manual/R-devel/library/base/html/sample.html

00000000oDO00onoD0DoDODOD0D RODODODODODODO0D0D0DOD0D0 Ruby DODODODODODODODDOODODODODODODODODD

=end

#20 - 12/19/2010 08:13 PM - mame (Yusuke Endoh)

=begin
aoooo

20100120190014:06 Masaya TARUI tarui@prx.jp:
#364700000000000000000000s00000000000
1)0000000000000000
2)10000000000000-1000 -10000000000000)
3)00000000000000000000000

Qo0oonoooboooooooonnooo

4) 0000000000000 o OOD (OODOODOY
gooooooo
00o0bopoonooooo

OR
http://stat.ethz.ch/R-manual/R-devel/library/base/html/sample.html

sample(000, 000000, replace 0000 = false, 00 = nily

000000000000000000000000000o0a0
00000000o0oononoDoD (DoC 4 DODy O

O Matlab
http://www.mathworks.com/help/toolbox/stats/randsample.htmi

randsample((00, 000000, replace 0000 = false, 00 = nil)

00000000oDoDoDoooonoDoDoDoD (ooo
3000y 0

O Mathematica
http://stat.ethz.ch/R-manual/R-devel/library/base/html/sample.html
mailto:tarui@prx.jp
http://stat.ethz.ch/R-manual/R-devel/library/base/html/sample.html
http://www.mathworks.com/help/toolbox/stats/randsample.html

http:/reference.wolfram.com/mathematica/ref/RandomSample.html
http://reference.wolfram.com/mathematica/ref/RandomChoice.html

RandomSample[l00, 000000;
RandomSample[l0->000, 000000
RandomChoice[l100, 000000;
RandomChoice[l0->000, 000000]

100000 RandomSample 000000 RandomChoice [I
-> (000000000000

0000000000O00000D0D0D0D0no0a0anD
00000000O0O 4 000D

10000000000000000000000RandomSample [
(1000000000000000000 (000 Ruby O shuffle
(0) DRandomChoice I 1 000000000000 (Ruby O
sample [0y 00000Ruby 00000000000000000

O Python
http://docs.python.org/library/random.html

choice(000) #1 00000
shuffle(d00)
sample(000, 000000)
00000000000000D¢?)

HHH[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I

0000o00oooooonoonooonoonan
sample 100000 o(n) 00000000000000000
00000000000000000000 sum OODODOODDO
000o00ooonooboonooononooa

Yusuke Endoh mame@tsg.ne.jp

=end

#21 - 12/19/2010 08:18 PM - mame (Yusuke Endoh)

=begin
aoooo

201000120019[114:33 Urabe Shyouhei shyouhei@ruby-lang.org:
(2010/12/19 14:02), Yusuke ENDOH wrote:

00000 [ruby-dev:42791] 00000000000000000000
I]DI]DI]DI]I]DI]DI]D[II]I][II][II] matz [0000000000000000
(uad)

000000000wunk0000O0O000D0DODODODODODOODOD
ooonoo
00000000000000000000000000000000000000a
00000000oDonoonononoDoDononoDnaD
00000000000000matz DO0OODO0OD new feature O
0000oboDopopoooonono
000000000 matz 0000000000000000000 new
teature J000000000000000000000000O0O0D

000000000000000 (00000 matz O0OOOOOOO
000boboooooooy 0

Yusuke Endoh mame@tsg.ne.jp

=end
http://reference.wolfram.com/mathematica/ref/RandomSample.html
http://reference.wolfram.com/mathematica/ref/RandomChoice.html
http://docs.python.org/library/random.html
mailto:mame@tsg.ne.jp
mailto:shyouhei@ruby-lang.org
mailto:mame@tsg.ne.jp

#22 - 12/19/2010 08:22 PM - mame (Yusuke Endoh)

=begin
aoooo

2010001200190015:20 Yoji Ojima redmine@ruby-lang.org:

0000oDoDoooonoDoDoDoDoDoDoDooooD

R 0000000ODODODODODODODDODODOD

http://stat.ethz.ch/R-manual/R-devel/library/base/html/sample.html

000000o0O000DOD0D0DODO0ODOD RODODODODODODO000DODOD0D0 Ruby ODODODODODODOODODODODODODODODOCOD

Oruby 000000000000000000000000000
0oooooooooooooDDDDDDDDDDDDDDDD
00000000000oooD0DDD00DDDDD
take_while 00000

00000000000000000000000000000on
HHHDDDDDDDDDDDDDDDDDDDDDDDDDDDD

Yusuke Endoh mame@tsg.ne.jp

=end

#23 - 12/19/2010 09:15 PM - yugui (Yuki Sonoda)

=begin
Yuguillll0

2010/12/19 Masaya TARUI tarui@prx.jp:

00000000000000000000000000Dan0o00oa0Da0OE00Da0Da0ED
0000000000o0bonoobonoononDononDg

000DoDoDoDopoooononong

000000000000000000000000000o0a0a0000n0Dn0Dg
0000o0oDoooonoDoDonon

« 0000000000O00DO0DO00D

* [ruby-dev:41918] [00000000000000000000000000000000000000000000

« mrkn[ll0Math/RandomU000000000000000000DO000DO000DO0ODDA0DDDOODOND
o mrkn000000Array#sampled000000000

Yuki Sonoda (Yugui)
yugui@yugui.jp
http://yugui.jp

=end
#24 - 12/19/2010 10:45 PM - oj (Yoji Ojima)
=begin

00oo000000ooooooooonooooonn

sample 000000 o(n) D000000000DDOOOO0

00000000O0O00000 walker's alias method O0000000000000000000000000000000000000O00000D0D0DODODODODO00ODODOD0D0DO0a0AD

=end
#25 - 12/19/2010 10:52 PM - matz (Yukihiro Matsumoto)

=begin
0000 booooo

In message "Re: [ruby-dev:42806] Re: [Ruby 1.9-Feature#4147] Array#tsample 100000000
on Sun, 19 Dec 2010 20:17:57 +0900, Yusuke ENDOH mame@tsqg.ne.jp writes:

|DDDDDDDDDDDDDDmatz 0000000000 new feature
\000000000000bannoono

0000000000000000000000nonanana
0000000000000000000000000a0ana
0000000000000000000000nononann
00000boDoDoDoonoDoDoDoDoDoDanD

(000000000 matz 0000000000000000000 new
lfeature 000000000000000000000000000000
(000000000000000 (000000 matz ODODOODO
\000000000000D) a

00O

=end

#26 - 12/20/2010 12:41 AM - mame (Yusuke Endoh)

=begin
goooo

20100120019[122:52 Yoji Ojima redmine@ruby-lang.org:

Q00000ooononnoonooonanooO
sample 000000 o) 00000000000000000

0000000000000000 walker's alias method
0000oDoDoooonoDoDoDODODODo000DODODoDoDaDaDa000D0D0D0DaDanaDaD00D0Dn0DoDaDnaDaD

Walker's alias method 000000000 r 0000000
(http://svn.r-project.org/R/trunk/src/main/random.c) 0000000
(0000000o0000000000 o(ny DDOOOOOODODD
0oooooooo

000 R O sample 001 00 2 0000000000000000000
000000oDoDoooonoDoDoDoDoDoDanO

« 1000000 << 00000000000
« (00 sample 000000000000000000000
o 000 o@000DO0) DODODOOD

0000oboDoDoDoDooo
Ruby 000000000000000000000

00000000 gem OODO0DODOODODOODODOODOOD
000oo0ooobooooonoonnoonoonDnOnDa

;usuke Endoh mame@tsg.ne.jp
=end
#27 - 12/20/2010 01:26 AM - oj (Yoji Ojima)
=begin
Ruby 000000000000000000000
10000000 gem OO000DDOOOOOODODDOOOOOO0
00000000000D000000000D000000000
000000000000000000000000000000000000000D00000000DD00000000D00

000000000000 (1..n).map { ary.sample }
[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I

=end

#28 - 12/20/2010 12:43 PM - mame (Yusuke Endoh)
=begin
noooo
201001202001:27 Yoji Ojima redmine@ruby-lang.org:
0000000000000000000000000000DD00000000D00000000oDO0000000DD0a

00000000000000000000000o0n000Dan0g
000000000000000000D o(og ny DODODODOD
0000000 Api 0 o) 00000000000000000000
000o00ooobooooonoonDonnoOnDOnDOnD

R [ matiab 0000000 om) 0 Ap1 00000000000000
000000000000000000000000000000000
00000000000000000000000
000000000000on) 0000D0000D000D.......0

000000000ooo (1..n).map { ary.sample }
I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I][II]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I][I[II]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]I]

0000000000O00000000000D0Dona0a0ang
000000ooopooo
00000000000 walker's method 0000000000

n 0000000 m 0ODDODODODODDODODODODDOD
1.0000 AP 00000000000 O(n * m)
2.0000 AP 000000000000 O(n + m log n)
3.0000 Ap1 D0walker's method 000000 O(m + n)
4. [ruby-dev:42794] 1 API 000000000000 O(m log n)

m << n 000001 00 30 o(n) 04 0 O(log n) [
m >> n 00000000 om) O

Yusuke Endoh mame@tsg.ne.jp

=end

#29 - 12/20/2010 02:06 PM - oj (Yoji Ojima)

=begin
(000000000000000000000000000000000D
0000000000000D00DO0 o(og n) DOODOODOD

0000000 Apt 0 o) 00000000000000000000
0000000000o0DOnooboDooDonDonaDDoD

000000000000000000000000000a00000000000000000000000000000000000A0] Ruby
DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD

00000000000O00000D0D0D0DODoDaDa00oD
0000o0oooooon
00000000000 walker's method 0000000000

0000000000000000000000000000000n000
00000000000000000000000000000a000000000000000000000000000000000000000000000000R
00000DoDoDoDoooonODODODODODoDa00000Dn0DODODODOnaDaDO000DnODODoDaDaDananaCOO

=end

#30 - 12/20/2010 09:32 PM - mame (Yusuke Endoh)

=begin
goooo

2010012[200014:06 Yoiji Ojima redmine@ruby-lang.org:

0000o0oDoooonoDoDoDoDoDoDoDonoonan
0000000000000000000 ogog ny 00000ODOD
0000000 Api 0 o(ny) 00000000000000O0O000
0000oDoDoonoboboDoDoDoDoonoDoDoDg

000000oDODoonoDODODODODoDaDO000D0D0D0DODODaDaD00D0DODODODODaDODO0D Ruby DODOODOODODODODODODODODOODODODODODD

00000bopoobopoobonoo
0000000ooDonooonoonnooooo0ha0Do0nDO0DO0DO0DDO0Da0DD

000000000000000000000000000000nanD

0000000000000000000000n000000o0

0000000000000000000000Do0o0non0oD

oooooooooooooa
000000000000000000000000000000000000000000000000000000000000000000000000000000R
q00o00oooDooooonDonnoonoOnDO0nDO0Da0DE0DDO0DO0DD00Da0DO00DO0DO0DD00Da00D

aooooo

Yusuke Endoh mame@tsg.ne.jp

=end

#31 - 12/20/2010 10:33 PM - oj (Yoji Ojima)
=begin

00000000000000000000000a00000no0g
00000DoDoDooooooDoDoDoDoDoDODOD

000000oDoDoDoooonODoDODODODODaDO000DnODnODg

HHHHHHHHHHHDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD

http://code.activestate.com/recipes/576564-walkers-alias-method-for-random-objects-with-diffe/

000000oDoDooboDoDoDoDoDoDODDnODODODODaD

=end

#32 - 12/20/2010 10:56 PM - akr (Akira Tanaka)

=begin

20100120190021:15 Yugui yugui@yugui.jp:
« 0000000DDDDOOOD000D

A
x = f(rand(n))

0000+, n 000D00ODODODODOODD

f, n = Random.00000000_00000000OD)

00000o0oonoononoonona
(call 00000000DODOODD)

f, n = Random.000000000000(beg..end) v 00}
f._n = Random.00000000000000(beg..end) {v| 0000 3

0000000000000000Do0no0noannaa
00o0bopoonooooo

000+, n 0O0DOODOODDOODOODOODDO0DO0DD0D
00000000Array#sample 000000000000000
mailto:yugui@yugui.jp

* [ruby-dev:41918] 0000000000000000000000000000D0DO0ODO00O0ODOD

000000000000000000

Array#tsample 100000 (10000000000000000) 000
[ruby-dev:41918] 00000000000

[ruby-dev:41919] 00000000000000000

(000ODoDODODooDODODODODODODO0DODODOD)

00000000000000000000DO00o0nDonDnanD
0000booooboobonoo

« mrkn[0Math/RandomU0000000000000000000O000DO000DO000DDODO0ODODDDD
Random [000000000000000000000
Array#sample 1000000000000000000
0000000000000000000000000000000
000000000000000000000000000g
000ooooooooooooo
il_][l (3000 D00j[Tanaka Akira]
=end

#33 - 12/21/2010 01:33 AM - mame (Yusuke Endoh)

=begin
oonoo

2010012[200022:33 Yoji Ojima redmine@ruby-lang.org:

00000000000000000000000000000000a
000000O0o0oooononoboDonononoDnaD

Q000000o0DooooooDonnooooo0DOnno0DDO0DanDD

00000000000000000000000a0a000no0ng
000000000000000000000o0a0a000n0Dg
0000o0oDoooonoDoDonoo

00000000000000000000000O000a0000000000000nO0aDa000Dn0D0D0DonODaDaDO000D0D0D0DOnODaDaDO0D0D0D0D0DODaDaDaDDDD
00oDoboooooooon

http://code.activestate.com/recipes/576564-walkers-alias-method-for-random-objects-with-diffe/

000000oDoonoDoDoDoDoDoDODooDODODoDoDaD

0000000000000000000o0o0noD
0000000000000000000000000 AP DOOO0O
000000o0oDopopoonononoDoDoDoDoD

0000 sample 00000000000000000n) 0000000
000000000 Api 0DODODOOOODODODODO0D
sample 000000000000000000000000000000
0000000000O0000000D0D0D0Dona0a0anO
0ooooooo

(000000 naruse 000 (re Oy 000000000O00DOO
Enumerator 00000 ap1 000000000000

e =%(00 00 00 0).sample_each
e.each {|x| p x } #=> [0 00 00 00

e= %([l[l 0o oo D).sample_each(unique: false, weight: [1000, 100, 10, 1])
e.each {|x| px} #=> 00000000 ...

0000oDoDoooonong

Yusuke Endoh mame@tsg.ne.jp

01/18/2021 12/24


mailto:redmine@ruby-lang.org
http://code.activestate.com/recipes/576564-walkers-alias-method-for-random-objects-with-diffe/
mailto:mame@tsg.ne.jp

=end

#34 - 12/21/2010 12:36 PM - oj (Yoji Ojima)
=begin

000000 naruse 000 re 0y 00000000000000
Enumerator 000000 AP 000000000000

e =%(00 00 00 0).sample_each
e.each {|x| p x } #=> [ 00 00 00

e= %(DD oo oo D).sample_each(unique: false, weight: [1000, 100, 10, 1])
e.each {|x| px}#=>00000000 ...

0000000oobooog
00 sample_each.each 00000000000000000000

=end
#35 - 12/21/2010 03:20 PM - naruse (Yui NARUSE)

=begin
goooooooooooooooa

« 0000000
« (00000 (00/0lock)
« 00 (000000000000000DO0000g)

== 0000000

00000000000000000000000000000nn0n0onnan
optional hash(100000000000000000 Array#choice 000000000
a000oooooooon

Array#choice [1 1.8.7 0000000000000000000000000000000
00000000Dooooog
sample/choice 0000 Mathematica 00000000 (see also [ruby-dev:42805])

== (0000

00000000000000000000000000000000000000a0ang
0000000000 ary 00ODODODOCDOCDODOOOO

00000000000 ary 00 hash 00000000000000000
00000000block 0OODODODODODODODOODODODODD

==00

0000000000000000000000000000000000000000onananO
0000000000O0000000000000000a00000D0D0D000nonanaDnD
00000000000000000000000000000 enumerator (D000 generator OOOD)
000000000000000000000000n000000n0ng
00000DoDoDoDoDoooonODoDoDoDoDoD

000000o0oonono
00 sample_each.each 00000000000000000000
00000 sample_each {|x| .. } 0000000000000000000

NARUSE, Yui
naruse@airemix.jp

=end

#36 - 12/21/2010 05:58 PM - oj (Yoji Ojima)

=begin
0oooooooooooooDoDDDDDDDDDDDDODDDDDDDDDDD

optional hash(00000000000000000 Array#choice aoooooooo
aooooooooooo
00000+.s.7 DODODODOODODODODODODODOOOODOD
000000000onoono

[0 sample_each.each 00000000000000000000

00000 sample_each {|x| .. } 1000000000000000000

000000o0oo

000000oo0bonooonoonhOnnoonDonna00oO0DO0DO0DD00DanDa

=end

#37 - 12/21/2010 09:35 PM - akr (Akira Tanaka)

=begin
20100120200022:56 Tanaka Akira akr@fsij.org:

000000000000000000DOnO0a000nonoDg
000DoDoDoDoooooon

Pavlos S. Efraimidis, Paul G. Spirakis
Weighted random sampling with a reservoir
Information Processing Letters

Volume 97, Issue 5 (16 March 2006)

000DoboDopoooonono

0000000000000000000o0noD
00000000oDO00ononoDoDonoDoD
00oDobooooo

1ooooo (0ooooy ooooooooo
ihDDHDDDDDDHTanakaAkhﬂ

=end

#38 - 12/22/2010 12:34 AM - akr (Akira Tanaka)

=begin
2010012[021021:35 Tanaka Akira akr@fsij.org:

Pavlos S. Efraimidis, Paul G. Spirakis
Weighted random sampling with a reservoir
Information Processing Letters

Volume 97, Issue 5 (16 March 2006)

000DoDopoooobonono

0000000000000000000o0naD
00000000O00000n0D0DoDonODaD
00onopooooo

000000 (ooooy 0bobonooa

00000o0oobooohonoobonoobonog
000o00ooonoonoonDonooooDoOnDa

% ./ruby -l /home/akr/ruby/depqg/lib -rdepq -e '
module Enumerable

def sample2(n)

Depg.nlargest(n, self) {|e| rand ** (1.0/(yield(e))) }
end

end

enum = (-20..20).to_a*10000

a = enum.sample2(20000) {|e| Math.exp(-(e/5.0)*2) }
h = a.categorize(:op=>:+) {le| [e,1] }

-10.upto(10) {|x| puts ™ * (h[x]/30.0).to_i }

*
*

[: 0 depq, categorize
EI-][I 0000 000j[Tanaka Akira]
=end

#39 - 12/22/2010 01:08 PM - akr (Akira Tanaka)

=begin
2010012021015:20 NARUSE, Yui naruse@airemix.jp:

== 0000000
Q00o00oooDooooooDonDooDoO0DO0DEO0DO0DEO

000000000000n0nonononanana
0000000000 DODODODonononoonoDoDononoDnaD
000Doboboooooonong

[ruby-dev:42735] 0000000000000000
[ruby-dev:42741] 00000000000000000000000000000
[ruby-dev:42797] 0000000000000

0000000000000000000000000000000000000
000000o0oDopopoonononoDng

EI-][I 0000 000j[Tanaka Akira]
=end

#40 - 12/22/2010 03:23 PM - naruse (Yui NARUSE)

=begin
2010001200210017:59 Yoji Ojima redmine@ruby-lang.org:

0000000000DDDO
oo sample_each.each 0o0oooooooooooooooon

00000 sample_each {|x| .. } 1000000000000000000

0000000000
q000000ooDooooonoonDooooo0Da0Do0DO0DO0DO0DDO0DO0DD

0000000o0boooooooonoa
goooooo

NARUSE, Yui
naruse@airemix.jp

01/18/2021 15/24


mailto:naruse@airemix.jp
mailto:redmine@ruby-lang.org
mailto:naruse@airemix.jp

=end

#41 - 12/22/2010 03:29 PM - naruse (Yui NARUSE)

=begin
2010012[22[113:08 Tanaka Akira akr@fsij.org:

2010012021015:20 NARUSE, Yui naruse@airemix.jp:
== 0000000
0000000000000000000DD0000000DDCO0000000D

00000000000000000000000000

0000000000 D0onoonoooooononooonooooonoo

aooooooonooooooooo

[ruby-dev:42735] 0000000000000000

[ruby-dev:42741] 000000000000000000000000D0000O

[ruby-dev:42797] 0000000000000

000000000000000000000000000D0000000nD

00000000000D00000000D000
Hﬁﬁ%ﬂDDDDDDDDDDDDDDDDDDDDDDDDDDRPGDDDDDDDDDDDDDDDDDD

« (0000000000000000000000000n000anD
« 000000000000000ODO000D0DO0O

- 0000000000000O0O0000

- 0000000000000

- 0000000D0DODODOD DODODODO

0000000ax00000000DO00CO0DO0DO00D

NARUSE, Yui
naruse@airemix.jp

=end

#42 - 12/22/2010 06:01 PM - oj (Yoji Ojima)

=begin
10000000000000000000000000000000000nD
00000ooooooDDDDDDODDDDDD

000000000000000000no0ng
000000oDopooboboboboDoDoDODonoDnODO

=end

#43 - 12/23/2010 02:00 PM - mrkn (Kenta Murata)

=begin
aooooa

yugui 1000000000000000000000D00D00DO0OD

# Math/Random 0000000000000000000000

On 2010/12/19, at 21:15, Yugui wrote:
2010/12/19 Masaya TARUI tarui@prx.jp:

00000000000000000000n0n00a0000000000000nana0a00000D
00o0oooDoonoboboDoDoDoDoDoooonOD

Q00oo0ooobooooooDooooO
00000000000000000000000000000000000000000
000000opoonoboDononoD

« (00000DO0O0DOCOODOCD
* [ruby-dev:41918] 000000000000000000D000O00DO00DO0DOO0DO0DOODDOD

000000000000000000 replace 000000000000000
000000000000000000000000 choice DODOOOD
0000oboDoDoDoDooo

. mrknﬂﬂDDDDArray#sampIeDDDDDDDDDD

000000000000000000000000o0nan
Ojima 0000000000 Array#sample 000000
(0000000000000D00000O
000000000000000000000000
000o00ooobonhoonoonnonnon

ojima 0000000000n0000000000000 Array#sample 00000000
0000o0opoooonobobonoo

¢ Array#sample 00oo00onnonnooonon
* Array#sample_by 0000000000000000000000000DO0

DDDDsort_by DDDDDDDDArray#sample 00000000o0oonoo
gooooooooboooa

0000000000O00000000000000onanananO
00000000000000000000000a0D o OOOOD
00000bonopoooonono

n 00000000000 walker 0000000000000000000000000
0000000000000000000000000000000000

walker 000000000 boost 0000000000000

000 CodeRepos [ hitp:/bit.ly/eAkiM1 0000000000000
00000000000000000

00ooooo

- 00000000000000000O0OD
- 00000000000000000O0

« (00000000000000000 DOODDO00O00oo0Da00oo0oo00a00C00Dha00000DO O0DO00 Array#sample 0OOODOOODOODOODOOODO

00000000oooooooooooEooooa
00 Random 00000

« mrknl00Math/Random000000000000000000000000000000000000D00DODO0G

0000000 Math/Random 00
« 000000

- 00000000000000DODOD0000D0D 000DODO0O00C0 DODODOD boost O random 00O0OOOOOODOD

IIE

gen = Math::Random::SFMT216091.new # Random.new [0
gen.() #0000000000000000DO0DDDOD

gen.int(min, max) # [min, max] 00000000000000

gen.real # [0, 1) 00000000000 (53-bity 000

ndist = Math::Random::NormalDistribution.new(0, 1) # 000000
ndist.(gen) # 00000000000000

0000000000000000000 random 0O0OOOOOODODOD
00oboboooo

#000000000000000000000000000000000000000a00000
# 00 TypedData 00000000000000000000 TypedData 0000000000
#0000000000000DODODO000DODOD

(000000 walker 00000000000000D00O00DOOD0ODD
aao Array#sample aoooooo Array#sample 0ooooooooooooooono
00000DoDoDoDoDoooonODODoDODODaD

00000000000000 walker 0000000000DOD
0000000000000000DonononanO

0000000 Array#sample 000000000000000000000
0000oboDoDopooooboDoDoDoD P

000oonooobooooonoononoono

00000000000O0000000000000000000000000000
0000000000 walker 00000000000000D000000O0OOD
00000000000000000000000a0000000000o0naD
00000000000000000000000000000a0
000000000000000000000000nonanann
000000000000000000000o0a0a000n0Dg
0000o0oDoooonoDoDonoo

Array#sample 00000000000000000000000
000000000Do00ooononnoonnonnannnonnanna

(000 GNU R [ sample 000000000000000000000000

aooon [ruby-dev:42817] nooooono Array#sample 10000000oooonon

00000000000000Array O Hash O000DO0DOO0DOOD
0000000000000bono0honoononog
00000Array#sample 00000000000000000000
000ooooouboonoonoonnoonoonhO0DooDDOnDaO

0000000000000000000[ruby-dev:42829] 00000000
00000 sample_each 000000000000000000000000000000
00000opooboooononooo

Kenta Murata
OpenPGP FP = 1D69 ADDE 081C 9CC2 2E54 98C1 CEFE 8AFB 6081 B062

aonaooay
ORuby 0000000 http://www.amazon.co.jp/dp/4798119881/mrkn-22

E-mail: mrkn@mrkn.jp
twitter: http:/twitter.com/mrkn/
blog: http://d.hatena.ne.jp/mrkn/

=end

#44 - 12/23/2010 02:56 PM - mame (Yusuke Endoh)
=begin

aoooo

20100120230014:00 Kenta Murata muraken@gmail.com:

000000000000000000 replace 00000O0O0000DO0O
000000000000000000000000 choice 0OODODDO
000000onopopooooo

000000000 ruby-core 0000000000000

00000 sample/choice 00000000000000000000
0000000000matz 0000000000O0DO0OODOD
00000 (replace 0000000000000000O0DO0DDO
00ooooooy 0

ojima 0000000000~0000000000000 Array#sample 00000000
00ooboooonoobonoobono

o Array#sample 000000000000000000

« Array#sample_by 000000000000000000000D00DO0D
IRC DDDsampIe(weight: proc{...}) nooooooooooo
gooobooooco
0000000D0000Donoono0nonoononooD

sort_by 00000000000000000D0000D
(00sample_each 000000000000000O
n 00000000000 walker 0000000000000000000000000
000000000000000000000000000000a00n

walker 000000000 boost 0000000000000

000 CodeRepos [ hitp:/bit.ly/eAkiM1 0000000000000
00000000000000000

000

00000mrkn 0ODODODODOODODODODODODOD
00000000000000000000000a0a000000a
000000onoDoooonoDoDoDoDoD

(000000000000000000000000000000000000000
1000000000 walker OOOO00000OOO0O00DDOOODOON
0000000000000000000000000000000O0000On
0000000000000000000DoO000no0noDa

snip

00000Array#sample 00000000000000000000
00000000000000DO0000O0000O000nan00DanoD

000000000000000000000000gem ODOODOD
000ooooooboonooooooooo
0000000000000000000[ruby-dev:42829] 00O0O0DD
00000 sample_each 000000000000000000000D0DO0DOODDO

000oonooobooooonoononoono

Yusuke Endoh mame@tsg.ne.jp

=end

#45 - 12/23/2010 03:04 PM - mame (Yusuke Endoh)

=begin
aoooo

(00000000000000000000 AP DOOODDOD
000000000sample_each 0 each_sample 00000000

Array#sample([size, [opt]])
e API

o size 1000000 1+ 00000000000
o size 0000000 size 100000000000000

o opt 000: weight: proc or array random: Random instance
« [0

o weight 100000000000000
o weight 0000000 akr 00000 [ruby-dev:42844]

Array#choice([size, [opt]])
o API
o size 1000000 1 00000000000
o size (000000 size 0OO0000000DOOO0O
o opt [l Array#tsample 000

« [0
o (0000 size 0000000 (weight 00000000000)

o Walker's alias method 00000 (size 00000000000 D0size 00000000000000000O0D00DODOD)

Array#each_sample([opt])

e API
o 10000000 yiela 00000 (D0000000DD0DD)
o 0000000000 Enumerator 000
o opt [l Array#tsample 000

« 00

o weight 00000000000000000
o weight 0000000 akr 00000 (00O0DODODDD)

Array#each_choice([opt])
¢ API

o 00000000 yield 00DOOOO0O
o 0000000000 Enumerator 000
o opt [l Arrayttsample 001

« [0

o weight 0000000000000000000
o weight 0000000 Walker's alias method 00000000

aaooooo
« %00 00 00 0).sample  #=> 0000000
O(DD 00 00 0).sample(4) #=> shuffle 000
%(00 00 00 0).sample(weight: [1000, 100, 10, 1) #=> 00000000 ({d000000)
(00 00 00 0y.sample(4, weight: [1000, 100, 10, 1)) #=> 000000000000 (00, »00-, 00", 0+ 0000000)

%

%
® %( aooooo D ).sample(4, weight: proc {|x| ... } )
#=> 100000000000 ([I[I[I proc [000D)

« %(00 00 00 Oy.choice  #=> 0000000

» %00 00 00 0).choice(4) #=> choice [ 4 000000000

« %00 00 00 0).choice(weight: [1000, 100, 10, 1])
#=> 00000000 (oo0o00my

« %00 00 00 0).choice(4, weight: [1000, 100, 10, 1])
#=> 000000000000 00+, 00+, 0a-, *00+ 0000000y

e %00 00 00 0).each_samplefirst #=> sample 000
. %(DD oo oo D).each_sample.to_a #=> shuffle 000

« %00 00 00 0).each_sample(weight: [1000, 100, 10, 1]).take(4)
#=> (100000000000 00+, -00-, -00-, 0+ 0000000y

%00 00 00 O).each_choice.first #=> choice 000

%(00 00 00 [0y.each_choice.to_a #=> choice(4) 000

« %00 00 00 0).each_choice(weight: [1000, 100, 10, 1]).take(4)
#=> 000000000000 ¢0a0-, -0a-, -0d-, *00+ 0000000)

Yusuke Endoh mame@tsg.ne.jp

=end

#46 - 12/23/2010 03:15 PM - akr (Akira Tanaka)

=begin
2010012[22[118:01 Yoji Ojima redmine@ruby-lang.org:

000000000000000000o00O
Q000000ooDooooonoonDoonoonhOnno0D

000o00oooboonoonnonooonDnanD
000DoDoDooooooo

00000000000000D0D0Dononana
0000000000 (O0booy bobonooaooo
000bobobonoo

iﬁl[l 0000 000y[Tanaka Akira]

=end

#47 - 12/24/2010 09:29 AM - mrkn (Kenta Murata)

=begin
oooooo

On 2010/12/23, at 14:56, Yusuke ENDOH wrote:

ojima 0000000000n0000000000000 Array#sample 00000000
00ooooooonoobopooboono

o Array#tsample 000000000000000000
« Array#sample_by (000000000000000000000000000

IRC DDDsampIe(weight: proc{...}) nooooooooooo
goooooooooo

0000bo0ooboononoobonoa
weight [ proc 0000000000000000000000000000O0D

n 00000000000 walker 0000000000000000000000000
000000000000000000000000naonnnannn

walker 000000000 boost 0000000000000

000 CodeRepos [ hitp:/bit.ly/eAkiM1 D000000000000
000000000ooooooan

000

00000mrkn 0ODODODOOO0D0DODODODOCDOD
00000000000000000000000a000000a0a
000000o0oooononoboDonoDnoD

discrete_distribution.hpp O000000000000000 zipt_distribution.hpp 0000
DDDDDDzipf_distribution.hpp I Zipf-Mandelbrot noooooono

00 zipt-Mandelbrot 0000000000000000000000000000000CDO00O

000000000000000000000000000a00000n00g
00000 (@0o0oo0oy 0hononoDonoononoboDoDonanananon

Kenta Murata

OpenPGP FP = 1D69 ADDE 081C 9CC2 2E54 98C1 CEFE 8AFB 6081 B062

aaoooooo
ORuby 0000000 http:/www.amazon.co.jo/dp/4798119881/mrkn-22

E-mail: mrkn@mrkn.jp

twitter: http:/twitter.com/mrkn/
blog: http:/d.hatena.ne.jp/mrkn/

=end

#48 - 01/06/2011 10:30 PM - oj (Yoji Ojima)
=begin

(00000000000000000000 AP DOOODDOD
000000000sample_each O each_sample 00000000

000000000000000000nonoong
0000000000O0000000000000000OnaDaDa00n0n0n0D0noDaD
000000O0O00000D0D0D0Druby-core O0OODOODODODD
=end

#49 - 01/06/2011 11:01 PM - matz (Yukihiro Matsumoto)

=begin
(1000 0ooooo

In message "Re: [ruby-dev:42968] [Ruby 1.9-Feature#4147] Array#sample 000000000~
on Thu, 6 Jan 2011 22:30:42 +0900, Yoji Ojima redmine@ruby-lang.org writes:

|~00000000000000000000 AP OO0DOOOD
|>000000000sample_each [ each_sample 00000000

|

(00000000000000000000a000
(000000000000000000000000000000000Anna00hannaanDa
\00000000000000000000 ruby-core DOOOODODODOD

0000000,0000000000000000000000
000000000000000000each_sample, each_choice
00000000000000000000ruby-core00000
0000000000000

=end

#50 - 01/30/2011 07:14 PM - oj (Yoji Ojima)

=begin
0000000/0000000000000000000000
|]|]|]|]|]|]Dﬂﬂﬂﬂﬂﬂﬂﬂﬂﬂﬂeach_sample, each_choice

00000000000000000000ruby-corel0OON
00oobopoooooo

000DoboDopoooonono

« choice 100000000000000000000000000000
« (000000000 repeat: true O00DO0DOODDOD
e #each_sample [l #samples 0000000000

0000oboDopopoooonono

=end

#51 - 01/31/2011 06:29 AM - matz (Yukihiro Matsumoto)
=begin
aoon oooooo

In message "Re: [ruby-dev:43148] [Ruby 1.9-Feature#4147] Array#sample 000000000"
on Sun, 30 Jan 2011 19:14:20 +0900, Yoji Ojima redmine@ruby-lang.org writes:

\0000000000000na0on

|

- choice 000000000000000000000000000000
|- 0000000000 repeat: true 0000000000000

|- #each_sample [ #samples 0000000000

|
\0000000000000DOna0an

000000000000002000000000000000
00000DoDoDoooonoDoDoDoD

samplesﬂﬂﬂﬂﬂﬂﬂﬂﬂﬂEnumeratorﬂﬂﬂﬂﬂﬂﬂ
each_samplel0000000000000000000000
aoooooooooooono

=end

#52 - 05/21/2011 07:07 AM - shyouhei (Shyouhei Urabe)
000000000bo0noonoonno0noonDonno0nDonhanno0nDo0ha0n000Dha00O0nD00ha0nD00DO0na0DD00D DDODDOODDO0DO0DD0DDD

#53 - 12/01/2011 06:41 AM - naruse (Yui NARUSE)

- Target version set to 2.0.0
000000o0oDo0oonODODoDODODoDaDO000D0D0RPGDODODODD

http://tkool.jp/
http://d.hatena.ne.jp/ktakaki/20111201/p1

0000000000ping

#54 - 12/01/2011 10:51 AM - shyouhei (Shyouhei Urabe)

0000000000000000000000000000000000000na0ang
000000oDoDoDoooonODODoDODoDoDaDODDoDnODODODaDaD

#55 - 07/14/2012 01:45 PM - akr (Akira Tanaka)

0000000000O00000000000000ono0a00000n0D0DonaDaD
0000o0oDoooonoDoDonoD

000000000repeat: 0000DODODODODODODOODODODODODODODODODD
000000O0o0oobonoboDononono0nonODoDonoDaDanD
0000000000000000000000000a0a0ang

0000000000000000000o0o0noD
000000oDoDooboDoDoDoDoDODO0DnoDODoDoDoDaDaDD

#56 - 10/25/2012 11:53 PM - yhara (Yutaka HARA)

- Target version changed from 2.0.0 to 2.6

#57 - 10/01/2014 03:34 AM - gogotanaka (Kazuki Tanaka)
gonoo

00000000000000000000000000Da0no0nDa0na0no00DanDa
00000o0ooDoohonoobonoo

000000onopoooononoboDonononanD
000000oDoDoDoonoDODODODODODaDa00O0DnODnODg

#58 - 10/01/2014 11:44 AM - naruse (Yui NARUSE)
- Assignee deleted (shyouhei (Shyouhei Urabe))

gogo tanaka wrote:

onooo.

00000000000000000000000DoO0Da00oo0Da0na0DD00Da00D
00000o0oonoobonooDonoO

q00o00oooboooooononooonoonnOnD
000000000000000000000000000000000000DanDa
0000000ooDoohonoobonooDonDono0DoDoO

Q00o00oooDooooooDonooonoo0DO0noo0Da0DEO

00000000000000nonong
00000DoDoDoDoDoooononoDng

#59 - 12/04/2014 01:13 AM - shyouhei (Shyouhei Urabe)
Yui NARUSE wrote:
00000000000000000000
000000DDDDDDDDDDDDDDDDDD
ooooooo

HHHHHHHHHHH#1DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD
#60 - 11/21/2016 04:59 AM - hsbt (Hiroshi SHIBATA)
- Status changed from Assigned to Feedback

01/18/2021 24/24


http://www.tcpdf.org

